<template>
  <div class="container mt-5">
    <h2>Cadastro de Componentes</h2>
    <div class="panel-group">
      <div class="panel panel-default">
        <div class="card-header">
          <div class="form-group row">
            <div class="col-md-9">
              <input
                type="text"
                class="form-control"
                name="descricao"
                v-model="stringBusca"
                placeholder="Descrição"
                required
              />
            </div>
            <div class="col-md-3">
            <a class="btn btn-warning float-right" @click="buscar(stringBusca)">
              <i class="fas fa-search"></i>buscar
            </a>
            </div>

            <div class="card-body">
              <form @submit.prevent="salvar">
                <div class="form-group">
                  <div class="form-label-group">
                    <input
                      type="text"
                      class="form-control"
                      name="descricao"
                      v-model="componente.descricao"
                      placeholder="Descricao"
                      required
                    />
                    <label>Descricão</label>
                  </div>
                </div>
                <div class="form-group">
                  <div class="form-label-group">
                    <input
                      type="text"
                      class="form-control"
                      name="valorComponente"
                      v-model="componente.valorComponente"
                      placeholder="Valor"
                      required
                    />
                    <label>Valor</label>
                  </div>
                </div>

                <div class="form-label-group">
                  <div class="form-label-group">
                    <input
                      type="text"
                      class="form-control"
                      name="quantidade"
                      v-model="componente.quantidade"
                      placeholder="Quantidade"
                      required
                    />
                    <label>Quantidade</label>
                  </div>
                  <a
                    type="submit"
                    class="btn btn-success text-white float-right text-white"
                    value="Salvar"
                    @click="salvar()"
                  >
                    <i class="fas fa-plus-circle"></i>Adicionar
                  </a>
                </div>
              </form>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!--------------------------------------------------------->
    <div
      id="accordion"
      v-for="componente in componentes"
      v-bind:key="componente.id"
    >
      <div class="card">
        <div class="card-header">
          <a
            data-toggle="collapse"
            aria-expanded="false"
            class="dropdown-toggle mb-3"
            :href="'#n' + componente.id"
          >
            {{ componente.descricao }}
          </a>
        </div>
        <div
          v-bind:id="'n' + componente.id"
          class="collapse list-unstyled"
          data-parent="#accordion"
        >
          <div class="card-body">
            ID: {{ componente.id }}
            <hr />
            Descrição: {{ componente.descricao }}
            <hr />
            Valor do Componente: {{ componente.valorComponente }}
            <hr />
            Quantidade em Estoque: {{ componente.quantidade }}
            <a
              data-toggle="collapse"
              href="'#' + componente.id"
              class="btn btn-edit btn-warning"
              @click="editar(componente.id)"
            >
              <i class="fa fa-cog mr-2"></i>
              <i class="ml-1">Editar</i>
            </a>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import axios from "axios";

export default {
  data() {
    
    return {
      stringBusca :'',
      componentes: null,
      componente: {
        id: null,
        descricao: null,
        valorComponente: null,
        quantidade: null,
      },
    };
  },
  methods: {
    listar() {
      axios
        .get(this.$MainURL + "/componentes")
        .then((response) => (this.componentes = response.data));
    },
    buscar(nome) {
      if (!nome) {
        this.listar();
      } 
      else {
        axios
          .get(this.$MainURL + "/componentes/" + nome)
          .then((response) => (this.componentes = response.data));
      }

    },
    salvar() {
      if (this.componente.id) {
        axios
          .put(
            this.$MainURL + "/componentes/" + this.componente.id,
            this.componente
          )
          // eslint-disable-next-line no-unused-vars
          .then((response) => {
            alert(`Ok, Alterado com sucesso`);
            this.listar();
            this.componente = {};
          });
      } else {
        axios
          .post(this.$MainURL + "/componentes", this.componente)
          .then((response) => {
            alert(`Ok, cadastrado com ID: ${response.data.id}`);
            this.listar();
            this.componente = {};
          });
      }
    },
    editar(id) {
      axios
        .get(this.$MainURL + "/componentes/" + id)
        .then((response) => (this.componente = response.data));
      
    },
    excluir(id, cod) {
      if (confirm(`Confirma exclusão do filme '${cod}`));

      axios
        .delete(this.$MainURL + "/componentes/" + id)
        // eslint-disable-next-line no-unused-vars
        .then((response) => {
          alert(`componente '${cod}' excluido com sucesso`);
          this.listar();
        });
    },
  },
  mounted() {
    this.listar();
  },
};
</script>

<style scoped>
.btn-edit {
  position: absolute;
  top: 0.5rem;
  right: 5px;
  z-index: 10;
  display: block;
  padding: 0.3rem 0.4rem;
  font-size: 0.9em;
  border: 1px solid;
  border-radius: 0.25rem;
  animation-direction: reverse;
}

.form-label-group {
  position: relative;
  margin-bottom: 1rem;
}

.form-label-group > input,
.form-label-group > label {
  height: 3.125rem;
  padding: 0.75rem;
}

.form-label-group > label {
  position: absolute;
  top: 0;
  left: 0;
  display: block;
  width: 100%;
  margin-bottom: 0; /* Override default `<label>` margin */
  line-height: 1.5;
  color: #495057;
  pointer-events: none;
  cursor: text; /* Match the input under the label */
  border: 1px solid transparent;
  border-radius: 0.25rem;
  transition: all 0.1s ease-in-out;
}

.form-label-group input::-webkit-input-placeholder {
  color: transparent;
}

.form-label-group input:-ms-input-placeholder {
  color: transparent;
}

.form-label-group input::-ms-input-placeholder {
  color: transparent;
}

.form-label-group input::-moz-placeholder {
  color: transparent;
}

.form-label-group input::placeholder {
  color: transparent;
}

.form-label-group input:not(:placeholder-shown) {
  padding-top: 1.25rem;
  padding-bottom: 0.25rem;
}

.form-label-group input:not(:placeholder-shown) ~ label {
  padding-top: 0.25rem;
  padding-bottom: 0.25rem;
  font-size: 12px;
  color: #777;
}
@supports (-ms-ime-align: auto) {
  .form-label-group > label {
    display: none;
  }
  .form-label-group input::-ms-input-placeholder {
    color: #777;
  }
}

/* Fallback for IE
-------------------------------------------------- */
@media all and (-ms-high-contrast: none), (-ms-high-contrast: active) {
  .form-label-group > label {
    display: none;
  }
  .form-label-group input:-ms-input-placeholder {
    color: #777;
  }
}
</style>
